%{!?apxs:    %{expand: %%define apxs    %{_sbindir}/apxs}}
%{!?libtool: %{expand: %%define libtool %{_sysconfdir}/httpd/build/libtool}}
%define aplibdir       %(%{apxs} -q LIBEXECDIR)
%define apconfdir      %(%{apxs} -q SYSCONFDIR)
%define aplogdir       logs
%define tc4dir         %{_datadir}/tomcat4
%define section        free

Summary:        Tomcat mod_jk connector for Apache
Name:           mod_jk
Version:        1.2.4
Release:        1jpp
Epoch:          0
Vendor:         JPackage Project
Distribution:   JPackage
License:        Apache Software License
Group:          Internet/WWW/Servers
URL:            http://jakarta.apache.org/tomcat/
Source:         http://jakarta.apache.org/builds/jakarta-tomcat-connectors/jk/release/v1.2.4/src/jakarta-tomcat-connectors-jk-1.2.4-src.tar.gz
Source1:        mod_jk.conf.sample
Source2:        workers.properties.sample
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  libtool, %{apxs}, %{_bindir}/perl, jpackage-utils >= 0:1.5

%description
Tomcat mod_jk connector for Apache.

By default, this package builds mod_jk for Apache 1.3.x.  To build for
Apache 2.0.x, use the "--with apache2" option for the rpm build
command.  To use a custom apxs, use "--define 'apxs /path/to/your/apxs'".
Additionally, for Apache 2.0.x, if your "apxs -q LIBTOOL" doesn't return
anything and the libtool that comes with Apache isn't located in
%{libtool}, use "--define 'libtool /path/to/your/libtool'".

%package        ap13
Summary:        Tomcat mod_jk connector for Apache 1.3.x
Group:          Internet/WWW/Servers
Provides:       mod_jk = %{epoch}:%{version}-%{release}
Obsoletes:      tomcat-mod

%description    ap13
Tomcat mod_jk connector for Apache 1.3.x.

%package        ap20
Summary:        Tomcat mod_jk connector for Apache 2.0.x.
Group:          Internet/WWW/Servers
Provides:       mod_jk = %{epoch}:%{version}-%{release}
Obsoletes:      tomcat-mod

%description    ap20
Tomcat mod_jk connector for Apache 2.0.x.

%package        manual
Summary:        Tomcat mod_jk connector manual
Group:          Internet/WWW/Servers

%description    manual
Tomcat mod_jk connector manual.

%package        tools
Group:          Internet/Log Analysis
Summary:        Analysis and report tools for mod_jk

%description    tools
Miscellaneous mod_jk analysis and report tools.

# -----------------------------------------------------------------------------

%prep
%setup -q -n jakarta-tomcat-connectors-jk-%{version}-src
perl -pi -e 's|/usr/local/bin\b|%{_bindir}|' jk/tools/reports/*.pl
install -p -m 0644 %{SOURCE1} %{SOURCE2} .
perl -pi -e \
  's|\@confdir\@|%{apconfdir}| ;
   s|\@logdir\@|%{aplogdir}| ;
   s|\@tomcatdir\@|%{tc4dir}| ;
   s|\@java_home\@|%{java_home}|' \
  mod_jk.conf.sample workers.properties.sample
mkdir -p _ap20
grep -v ^AddModule mod_jk.conf.sample > _ap20/mod_jk.conf.sample

# -----------------------------------------------------------------------------

%build

cd jk/native

[ -x ./configure ] || sh ./buildconf.sh
%configure \
  --with-apxs=%{apxs} \
  --with-java-home=%{java_home} \
  --with-java-platform=2 \
  --enable-jni \
%{!?_with_apache2:  --enable-EAPI}

# See <http://marc.theaimsgroup.com/?l=tomcat-dev&m=105600821630990>
%if %{?_with_apache2:1}%{!?_with_apache2:0}
export LIBTOOL=`%{apxs} -q LIBTOOL 2>/dev/null`
# Handle old apxs (without -q LIBTOOL), eg Red Hat 8.0 and 9.
if test -z "$LIBTOOL"; then
  LIBTOOL=%{libtool}
fi
make %{?_smp_mflags} LIBTOOL="$LIBTOOL" EXTRA_CFLAGS="$RPM_OPT_FLAGS"
%endif

%if %{?_with_apache2:0}%{!?_with_apache2:1}
make %{?_smp_mflags} EXTRA_CFLAGS="$RPM_OPT_FLAGS"
%endif

cd ../..

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 0755 $RPM_BUILD_ROOT%{aplibdir}

install -p -m 0755 \
  jk/native/jni/jk_jnicb.so $RPM_BUILD_ROOT%{aplibdir}/jk_jnicb.so

%if %{?_with_apache2:1}%{!?_with_apache2:0}
install -p -m 0755 \
  jk/native/apache-2.0/mod_jk.so $RPM_BUILD_ROOT%{aplibdir}/mod_jk.so
%endif

%if %{?_with_apache2:0}%{!?_with_apache2:1}
install -p -m 0755 \
  jk/native/apache-1.3/mod_jk.so.0.0.0 $RPM_BUILD_ROOT%{aplibdir}/mod_jk.so
%endif

install -d -m 0755 $RPM_BUILD_ROOT%{_bindir}
install -p -m 0755 jk/tools/reports/*.pl $RPM_BUILD_ROOT%{_bindir}

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%if %{?_with_apache2:0}%{!?_with_apache2:1}
%files ap13
%defattr(-,root,root,-)
%doc LICENSE mod_jk.conf.sample workers.properties.sample
%{aplibdir}/*
%endif

%if %{?_with_apache2:1}%{!?_with_apache2:0}
%files ap20
%defattr(-,root,root,-)
%doc LICENSE _ap20/mod_jk.conf.sample workers.properties.sample
%{aplibdir}/*
%endif

%files manual
%defattr(0644,root,root,0755)
%doc jk/docs/*

%files tools
%defattr(-,root,root,-)
%doc jk/tools/reports/README.txt
%{_bindir}/*

# -----------------------------------------------------------------------------

%changelog
* Fri Jun 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.2.4-1jpp
- Use the libtool that comes with Apache 2 for building with it.
- Provide a fallback "--define 'libtool /path/to/your/libtool'".
- Thanks to Henri Gomez for the above fixes.

* Thu Jun 26 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.2.4-0.2jpp
- Add --with apache2 rpmbuild option.
- Add manual subpackage.

* Wed Jun 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.2.4-0.1jpp
- Made apxs customizable with
  "rpmbuild --rebuild --define 'apxs /path/to/your/apxs'".

* Wed Jun 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.2.4-0jpp
- Update to 1.2.4, massive spec cleanup (only mod_jk for Apache 1.3 now).

* Tue Dec 17 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.2-1jpp
- jtc 1.2.2
- add Obsoletes tomcat-mod

* Tue Nov 26 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.1-1jpp
- jtc 1.2.1
- add package mod_jk-tools (require gd 1.8.x and perl modules GD 1.4.1, 
  GD Graph, GD TextUtil  and StatisticsDescriptive)

* Tue Oct 08 2002 Henri Gomez <hgomez@users.sourceforge.net> 2.0.1-1jpp
- jtc snapshot from JK 2.0.1 beta release
- apr / apr-util / apr-devel packages required for JK2 build and Apache 1.3,
  you could find them at : http://ftp.falsehope.com/home/gomez/apr/
- apache2 / apache2-devel packages required Apache 2 build,
  you could find them at : http://ftp.falsehope.com/home/gomez/apache2/

* Fri Oct 04 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.0-2jpp
- jtc 1.2.0 built against Apache 2.0.43

* Wed Oct 02 2002 Henri Gomez <hgomez@users.sourceforge.net> 2.0.0-1jpp
- jtc snapshot from JK 2.0.0 beta release
- apr / apr-util / apr-devel packages required for JK2 build and Apache 1.3,
  you could find them at : http://ftp.falsehope.com/home/gomez/apr/
- apache2 / apache2-devel packages required Apache 2 build,
  you could find them at : http://ftp.falsehope.com/home/gomez/apache2/

* Wed Sep 25 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0.jk1.2.0-1jpp
- jtc snapshot from JK 1.2.0 release

* Fri Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0.4.1.9-1jpp
- jtc snapshot from tomcat 4.1.9 beta
- webapp not build since it requires autoconf > 2.5 not available in rpm distribs 

* Thu Feb 14 2002 Henri Gomez <hgomez@users.sourceforge.net>
- Initial tomcat-connectors release
- use the jakarta-tomcat-connectors-4.0.2-01-src 
  (which correct some auth problems with ajp13)

